<template>
  <div>
    <v-row dense>
      <GCol cols="12">
        <div class="mt-4">
          <DccLocalizedTextBlock
            v-model="value.name"
            i18n="dcc.common.measuringEquipmentType.name"
            validate="required"
          />
        </div>
      </GCol>
      <GCol cols="12" md="6">
        <GTextField
          v-model="value._attr.refType"
          i18n="dcc.common.attributes.refType"
          attr-ref-type
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.model"
          i18n="dcc.common.measuringEquipmentType.model"
          validate="notEmptyStringType"
        />
      </GCol>
    </v-row>
    <EquipmentClass
      v-if="value.equipmentClass"
      ref="equipmentClassType"
      v-model="value.equipmentClass"
      i18n="dcc.common.measuringEquipmentType.equipmentClassType"
      optional
      level="second"
      @delete="deleteEquipmentClass(value)"
    />
    <RichContent
      v-if="value.description"
      ref="richContentType"
      v-model="value.description"
      i18n="dcc.common.richContentType.description.title"
      optional
      class="mt-4"
      level="second"
      @delete="deleteRichContent(value)"
    />
    <Certificate
      v-if="value.certificate"
      ref="hashType"
      v-model="value.certificate"
      optional
      class="mt-4"
      level="second"
      i18n="dcc.common.measuringEquipmentType.hashType"
      @delete="deleteCertificate(value)"
    />
    <Contact
      v-if="value.manufacturer"
      ref="contactType"
      v-model="value.manufacturer"
      class="mt-4"
      optional
      i18n="dcc.common.measuringEquipmentType.contactType"
      level="third"
      v-bind="$attrs"
      @delete="deleteManufacturer(value)"
    />
    <IdentificationList
      v-if="value.identifications"
      ref="identificationListType"
      v-model="value.identifications"
      optional
      class="mt-4"
      level="second"
      @delete="deleteIdentifications(value)"
    />
    <QuantityList
      v-if="value.measuringEquipmentQuantities"
      ref="quantityType"
      v-model="value.measuringEquipmentQuantities"
      :card="true"
      level="second"
      class="mt-4"
      quantity-key="measuringEquipmentQuantity"
      primitive
      optional
      @delete="deleteMeasuringEquipmentQuantityList(value)"
    />
  </div>
</template>

<script>
import {
  ContactType,
  HashType,
  IdentificationListType,
  MeasuringEquipmentQuantityListType,
  RichContentType,
} from "@d-ptb/dcc-js";
import EquipmentClass from "../Common/EquipmentClass";
import { insertIf } from "~/assets/util/general";
import IdentificationList from "~/components/DCC/Common/IdentificationList";
import RichContent from "~/components/DCC/Common/RichContent";
import Certificate from "~/components/DCC/Common/Certificate";
import DccLocalizedTextBlock from "~/components/App/Form/XML/DccLocalizedTextBlock";
import GTextField from "~/components/App/Form/gTextField";
import GCol from "~/components/App/Common/GCol";
import Contact from "@/components/DCC/Common/Contact";
import XmlTextField from "@/components/App/Form/XML/XmlTextField";

export default {
  name: "MeasuringEquipment",
  components: {
    XmlTextField,
    Contact,
    // Needs to be imported asynchronously because of recursive components
    QuantityList: () => import("~/components/DCC/Common/QuantityList"),
    GCol,
    Certificate,
    GTextField,
    DccLocalizedTextBlock,
    RichContent,
    IdentificationList,
    EquipmentClass,
  },
  props: {
    value: Object,
    updateAvailableElements: Function,
  },
  computed: {
    availableElements() {
      return [
        "equipmentClassType",
        "richContentType",
        "hashType",
        "contactType",
        "identificationListType",
        "quantityType",
      ]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.measuringEquipmentType.${x}`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(this.value.equipmentClass, "equipmentClassType"),
        ...insertIf(this.value.identifications, "identificationListType"),
        ...insertIf(this.value.certificate, "hashType"),
        ...insertIf(this.value.manufacturer, "contactType"),
        ...insertIf(this.value.description, "richContentType"),
        ...insertIf(this.value.measuringEquipmentQuantities, "quantityType"),
      ];
    },
  },
  watch: {
    availableElements: {
      handler() {
        this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    async addElement(element) {
      switch (element) {
        case "equipmentClassType":
          this.$set(this.value, "equipmentClass", []);
          break;
        case "identificationListType":
          this.$set(
            this.value,
            "identifications",
            new IdentificationListType()
          );
          break;
        case "hashType":
          this.$set(this.value, "certificate", new HashType());
          break;
        case "contactType":
          this.$set(this.value, "manufacturer", new ContactType());
          break;
        case "richContentType":
          this.$set(this.value, "description", new RichContentType());
          break;
        case "quantityType":
          this.$set(
            this.value,
            "measuringEquipmentQuantities",
            new MeasuringEquipmentQuantityListType()
          );
          break;
      }
      await this.$nextTick();
      // We have to wait for 2 ticks because of the asynchronous import of quantityList
      await this.$nextTick();
      this.$refs[element].$el.scrollIntoView({
        behavior: "smooth",
      });
    },
    deleteCertificate(item) {
      confirm(this.$t("dcc.common.conditionType.certificate.confirmRemove")) &&
        this.$delete(item, "certificate");
    },
    deleteManufacturer(item) {
      confirm(
        this.$t("dcc.common.measuringEquipmentType.manufacturer.confirmRemove")
      ) && this.$delete(item, "manufacturer");
    },
    deleteEquipmentClass(item) {
      confirm(this.$t("dcc.common.equipmentClassType.confirmRemove")) &&
        this.$delete(item, "equipmentClass");
    },
    deleteRichContent(item) {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(item, "description");
    },
    deleteIdentifications(item) {
      confirm(this.$t("dcc.common.identificationListType.confirmRemove")) &&
        this.$delete(item, "identifications");
    },
    deleteMeasuringEquipmentQuantityList(item) {
      confirm(
        this.$t("dcc.common.measuringEquipmentListType.quantity.confirmRemove")
      ) && this.$delete(item, "measuringEquipmentQuantities");
    },
  },
};
</script>
